// Creates marker files for AR

// This thing is extremely basic, but offers the opportunity to
// get more reliable markers over the ones you get from those
// webcam apps

Marker m;
boolean [][] mouse_buffer;

void setup(){
  size(320, 320);
  background(0);
 // m = new Marker(16, 16 , null, this);//loadStrings("my.txt"), this);
 // don't ask me why but I prefer 8x8 markers
  m = new Marker(16, 16 , null, this);//loadStrings("my.txt"), this);
  mouse_buffer = new boolean[m.width][m.height];
}

void draw(){
  m.draw(g, 0, 0);
  if(mousePressed){
    int x = (int)(mouseX / m.xscale);
    int y = (int)(mouseY / m.yscale);
    x = min(m.width-1, x);
    y = min(m.height-1, y);
    x = max(0, x);
    y = max(0, y);
    if(!mouse_buffer[y][x]){
      if(m.m[y][x] == 0) m.m[y][x] = 254;
      else m.m[y][x] = 0;
      mouse_buffer[y][x] = true;
    }
  }
  else {
    mouse_buffer = new boolean[m.width][m.height];
  }
}

void keyPressed(){
  m.save();
}

class Marker{
  int width, height;
  int [][] m;
  PApplet p;
  float xscale, yscale;
  Marker(int width, int height, String [] data, PApplet p){
    this.width = width;
    this.height = height;
    this.p = p;
    xscale = p.width / width;
    yscale = p.height / height;
    m = new int[height][width];
    // grabs only the red colour from the first rotation of a file
    // you can expand on this yourself
    if(data != null){
      for(int i = 0; i < height; i++){
        for(int j = 0; j < data[i].length(); j+=4){
          String num = data[i].substring(j, j + 4);
          m[i][j/4] = getNum(num);
        }
      }
    }
    // or create a white page to draw on
    else {
      for(int r = 0; r < height; r++){
        for(int c = 0; c < width; c++){
          m[r][c] = 254;
        }
      }
    }
    draw(p.g, 0, 0);
  }
  // Get a number from the marker file
  int getNum(String num){
    while(num.charAt(0) == ' '){
      num = num.substring(1);
    }
    return Integer.parseInt(num);
  }
  // Format a number string for the marker file
  String stringNum(int n){
    String s = " "+n;
    while(s.length() < 4){
      s = " " + s;
    }
    return s;
  }
  // Draw to a graphics object
  void draw(PGraphics g, float offset_x, float offset_y){
    for(int y = 0; y < height; y++){
      for(int x = 0; x < width; x++){
        g.fill(m[y][x]);
        g.rect(offset_x + x * xscale, offset_y + y * yscale, xscale, yscale);
      }
    }
  }
  // Rotate the colour array anticlockwise
  int [][] rotate(int [][] m){
    int [][] temp = new int[height][width];
    for(int r = 0; r < height; r++){
      for(int c = 0; c < width; c++){
        temp[r][c] = m[c][height-1-r];
      }
    }
    return temp;
  }
  // Create a copy of the marker colours
  int [][] copy(int [][] m){
    int [][] temp = new int[height][width];
    for(int r = 0; r < height; r++){
      for(int c = 0; c < width; c++){
        temp[r][c] = m[r][c];
      }
    }
    return temp;
  }
  // Create the file string
  String [] createFile(){

    // the file is 4 rotations of the marker in r, g, b
    // (I've cheated here by doing only black - for colour,
    // expand m into r, g, b arrays)
    // each line is separated by carriage returns and small numbers are
    // filled in with spaces
    // each rotation is separated by a carriage return and a space

    // don't ask me why - and seeing as it will load any old shit in
    // I'm not going to buck the trend

    String [] data = new String[height * 3 * 4 + 4];
    int [][] temp = copy(m);
    int d = 0;
    for(int i = 0; i < 4; i++){
      if(i > 0) temp = rotate(temp);
      for(int n = 0; n < 3; n++){
        for(int r = 0; r < height; r++){
          String s = "";
          for(int c = 0; c < width; c++){
            s += stringNum(temp[r][c]);
          }
          data[d++] = s;
        }
      }
      data[d++] = " ";
    }
    String j = join(data, "\r");
    String [] file = {
      j        };
    return file;
  }
  // Save a pattern file and an image we can print out as a marker
  void save(){
    saveStrings("out.txt", createFile());
    PGraphics out = createGraphics(p.width + 300, p.height + 300, JAVA2D);
    out.beginDraw();
    out.noStroke();
    out.background(255);
    out.fill(0);
    out.rect(25, 25, p.width+250, p.height+250);
    out.fill(255);
    out.rect(125, 125, p.width+50, p.height+50);
    draw(out, 150, 150);
    out.endDraw();
    out.save("out.gif");
  }
}




